com.smartgwt.client.widgets

## Class FiscalCalendar

- java.lang.Object
- - com.smartgwt.client.core.JsObject
  - - com.smartgwt.client.core.DataClass
    - - com.smartgwt.client.core.RefDataClass
      - - com.smartgwt.client.widgets.FiscalCalendar

-     public class FiscalCalendar
      extends RefDataClass

  An object representing the start date for fiscal years in the current locale.

  A fiscal year spans a configurable date range - it may not exactly match a calendar year in length and it can start on any date within the calendar year and potentially end in the next calendar year.

  Developers may specify explicit fiscal year start dates by adding `FiscalYear` objects to the `fiscal years array`. If none are provided, or if there is no entry for the given year, one is manufactured based on the default `month` and `date`.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.RefDataClass

      `id`

    - ### Fields inherited from class com.smartgwt.client.core.JsObject

      `jsObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FiscalCalendar()`
    `FiscalCalendar(int defaultMonth, int defaultDate)`
    `FiscalCalendar(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Integer` | `getDefaultDate()` The default one-based day-number in the `specified month` to use for calculating fiscal dates when no `fiscal years` are provided.
    `java.lang.Integer` | `getDefaultMonth()` The default zero-based month-number to use for calculating fiscal dates when no `fiscal years` are provided.
    `FiscalYearMode` | `getDefaultYearMode()` This attribute controls how the displayed fiscalYear value should be calculated for dates falling within a period not explicitly listed in the +lik{fiscalCalendar.fiscalYears,fiscal years array}.
    `FiscalYear[]` | `getFiscalYears()` An array of `FiscalYear objects` which each represent the start date of a single fiscal year.
    `static FiscalCalendar` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `void` | `setDefaultDate(java.lang.Integer defaultDate)` The default one-based day-number in the `specified month` to use for calculating fiscal dates when no `fiscal years` are provided.
    `void` | `setDefaultMonth(java.lang.Integer defaultMonth)` The default zero-based month-number to use for calculating fiscal dates when no `fiscal years` are provided.
    `void` | `setDefaultYearMode(FiscalYearMode defaultYearMode)` This attribute controls how the displayed fiscalYear value should be calculated for dates falling within a period not explicitly listed in the +lik{fiscalCalendar.fiscalYears,fiscal years array}.
    `void` | `setFiscalYears(FiscalYear... fiscalYears)` An array of `FiscalYear objects` which each represent the start date of a single fiscal year.
    `void` | `setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)`

    - ### Methods inherited from class com.smartgwt.client.core.RefDataClass

      `getRef, getRef, internalSetID`

    - ### Methods inherited from class com.smartgwt.client.core.DataClass

      `doAddHandler, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsDoubleArray, getAttributeAsFloat, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAttributes, getHandlerCount, getJsObj, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject`

    - ### Methods inherited from class com.smartgwt.client.core.JsObject

      `equals, hashCode, isCreated, setJsObj`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FiscalCalendar

          public FiscalCalendar()

    - #### FiscalCalendar

          public FiscalCalendar(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### FiscalCalendar

          public FiscalCalendar(int defaultMonth,
                        int defaultDate)

  - ### Method Detail

    - #### getOrCreateRef

          public static FiscalCalendar getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setJavaScriptObject

          public void setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setDefaultDate

          public void setDefaultDate(java.lang.Integer defaultDate)

      The default one-based day-number in the `specified month` to use for calculating fiscal dates when no `fiscal years` are provided. This value together with `defaultMonth` will be used as the start date for the fiscal years where no explicitly specified fiscalYear configuration is present.
      See also `defaultYearMode`.
      Parameters:
        `defaultDate` - defaultDate Default value is null

    - #### getDefaultDate

          public java.lang.Integer getDefaultDate()

      The default one-based day-number in the `specified month` to use for calculating fiscal dates when no `fiscal years` are provided. This value together with `defaultMonth` will be used as the start date for the fiscal years where no explicitly specified fiscalYear configuration is present.
      See also `defaultYearMode`.
      Returns:
        Integer

    - #### setDefaultMonth

          public void setDefaultMonth(java.lang.Integer defaultMonth)

      The default zero-based month-number to use for calculating fiscal dates when no `fiscal years` are provided. This value together with `defaultDate` will be used as the start date for the fiscal years where no explicitly specified fiscalYear configuration is present.
      See also `defaultYearMode`.
      Parameters:
        `defaultMonth` - defaultMonth Default value is null

    - #### getDefaultMonth

          public java.lang.Integer getDefaultMonth()

      The default zero-based month-number to use for calculating fiscal dates when no `fiscal years` are provided. This value together with `defaultDate` will be used as the start date for the fiscal years where no explicitly specified fiscalYear configuration is present.
      See also `defaultYearMode`.
      Returns:
        Integer

    - #### setDefaultYearMode

          public void setDefaultYearMode(FiscalYearMode defaultYearMode)

      This attribute controls how the displayed fiscalYear value should be calculated for dates falling within a period not explicitly listed in the +lik{fiscalCalendar.fiscalYears,fiscal years array}.

      The `defaultMonth` and `defaultDate` will be used to calculate the start of the fiscal year period. The defaultYearMode determines whether the reported fiscalYear for this period matches the year in which the period starts or the year in which it ends (so whether a fiscal year spanning dates within both 2020 and 2021 is reported as fiscalYear 2020 or 2021).

      Parameters:
        `defaultYearMode` - defaultYearMode Default value is "end"

    - #### getDefaultYearMode

          public FiscalYearMode getDefaultYearMode()

      This attribute controls how the displayed fiscalYear value should be calculated for dates falling within a period not explicitly listed in the +lik{fiscalCalendar.fiscalYears,fiscal years array}.

      The `defaultMonth` and `defaultDate` will be used to calculate the start of the fiscal year period. The defaultYearMode determines whether the reported fiscalYear for this period matches the year in which the period starts or the year in which it ends (so whether a fiscal year spanning dates within both 2020 and 2021 is reported as fiscalYear 2020 or 2021).

      Returns:
        FiscalYearMode

    - #### setFiscalYears

          public void setFiscalYears(FiscalYear... fiscalYears)

      An array of `FiscalYear objects` which each represent the start date of a single fiscal year.
      Parameters:
        `fiscalYears` - fiscalYears Default value is null

    - #### getFiscalYears

          public FiscalYear[] getFiscalYears()

      An array of `FiscalYear objects` which each represent the start date of a single fiscal year.
      Returns:
        FiscalYear